import '../coins_base.dart';
import 'package:bip39/bip39.dart' as bip39;
import 'package:bitcoin_flutter/bitcoin_flutter.dart' as btcCore;
import 'bitcoinTransaction.dart';
import '../wallet_hd_coins.dart';
class CoinsBtc extends CoinsBase{
  @override
  String get coinType => "BTC";
  @override
  int get decimals => 8;
  @override
  Future<String>  getAddress(String subPath) async {
    // btcCore.HDWallet hdWalletBtc =
    // btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic), network:network)
    //     .derivePath(derivePath(subPath));
    // String btcAddress = hdWalletBtc.address;

    btcCore.HDWallet hdWalletBtc = hdMain.derivePath(derivePath(subPath));
    String btcAddress = hdWalletBtc.address;
    return btcAddress;
  }

  @override
  Future<String> getPrivateKey(String subPath) async {
    btcCore.HDWallet hdWalletBtc = hdMain.derivePath(derivePath(subPath));
    return hdWalletBtc.wif;
    // btcCore.HDWallet hdWalletBtc =
    // btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic),network:network)
    //     .derivePath(derivePath(subPath));
    // return hdWalletBtc.wif;

  }

  // @override
  // Future<String> getPrivateKey(String subPath) async {
  //   btcCore.HDWallet hdWalletBtc =
  //   btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic))
  //       .derivePath(derivePath(subPath));
  //   return hdWalletBtc.wif;
  // }


  /** ===目前 只能完成一个冷地址向一个地址 打币
   * subPath  :一个冷地址对应的 分仓路径
   * fromAddress：一个冷地址
   * toAddress：收币地址
   * amount：打币金额
   * gasPrice：手续费
   * otherPrams：冷地址 的 UTXO
   */
  // @override
  // Future<String> transactionMain_Old(String subPath,String fromAddress, String toAddress, num amount, num gasPrice, Map otherPrams) async {
  //   String privateKey = await getPrivateKey(subPath);
  //   print("privateKey="+privateKey);
  //   List<BitcoinIn> unspand = otherPrams["unspand"];
  //   Btransaction btransaction = await BitcoinTransaction.createBitcoinTransaction(
  //       fromAddress, toAddress, amount, gasPrice,network,decimals,type:coinType,
  //       unspends: unspand);
  //   String txPack = await BitcoinTransaction.signBitcoinTransaction(
  //       privateKey, btransaction);
  //   print("txPack");
  //   print(txPack);
  //   return txPack;
  //
  // }

  @override
  Future<String> transactionToken(String subPath,String fromAddress, String toAddress, num amount, num gasPrice,String contractAddress,int decimalForToken, Map otherPrams) async {
    String privateKey = await getPrivateKey(subPath);
    List<BitcoinIn> unspand = otherPrams["unspand"];
    //int dec = decimalForToken;//otherPrams["decimals"];//token的精度往往与主链不一样，所以要传进来
    Btransaction btransaction = await BitcoinTransaction.createOmniTransaction(
        fromAddress, toAddress, amount, gasPrice,network,decimalForToken,addressType:isEmpty(contractAddress)?"31":contractAddress, //也可以支持TUSDT
        unspends: unspand);
    String txPack = await BitcoinTransaction.signBitcoinTransaction(
        privateKey, btransaction);
    return txPack;
  }

  @override
  String  derivePath(String subPath){ //m/44'/0'/0'/0/0
    return "m/44'/0'/$subPath";
  }

  @override
  // Object get network => btcCore.bitcoin;
  Object get network {
    if(WalletHdCoins.isTestNetWork)
      return btcCore.testnet;
    return btcCore.bitcoin;
  }

  @override
  String get coinInfo => "比特币（Bitcoin）";

  @override
  String get imagePath => "coin/BTC";

  // @override
  // bool get isHaveToken => false;

  @override
  bool get isOpen => true;




  /**
   * 2021-4-2 自行开发
   * subPath: 无用
   */
  @override
  Future<String> transactionMain(String subPath,String fromAddress, String toAddress,
      num amount, num gasPrice, Map otherPrams) async {

    //1. 取到UTXO
    List<BitcoinIn_eb> unspands = otherPrams["unspand"];
    //2. 创建 私钥对象列表
    List<Secrets> mSecrets =new List<Secrets>();
    //3. 得到私钥 并载入
    for(int i=0;i<unspands.length;i++){
      String privateKey = await getPrivateKey(unspands[i].subpath);
      Secrets mdSc=new Secrets(i,privateKey);
      mSecrets.add(mdSc);
    }


    //4. 创建交易
    Btransaction btransaction = await BitcoinTransaction.createBitcoinTransaction_eb(
        toAddress, amount, gasPrice,network,decimals,type:coinType,
        unspends: unspands);
    //5. 送签名
    String txPack = await BitcoinTransaction.signBitcoinTransaction_eb(
        mSecrets, btransaction);
    // print("txPack");
    // print(txPack);
    return txPack;

  }

}