
import 'package:bitcoin_flutter/bitcoin_flutter.dart' as btcCore;
import '../wallet_hd_coins.dart';
import 'coins_btc.dart';

class CoinsLtc extends CoinsBtc{
  @override
  String get coinType => "LTC";
  @override
  int get decimals => 8;

  // String get derivePath => "m/44'/2'/0'/0/0";
  @override
  String  derivePath(String subPath){
    print( "m/44'/2'/$subPath");
    return "m/44'/2'/$subPath";
  }
  @override
  //2021-3-30 注释 先启用 下方的测试地址
//  Object get network => _litcoin;
  Object get network {
    if(WalletHdCoins.isTestNetWork)
      return testnet;
    return _litcoin;
  }
  static final _litcoin = new btcCore.NetworkType(
      messagePrefix: '\x19Litecoin Signed Message:\n',
      bech32: 'ltc',
      bip32: new btcCore.Bip32Type(
          public: 0x019da462, private: 0x019d9cfe),
      pubKeyHash: 0x30,
      scriptHash: 0x32,
      wif: 0xb0);


  static final testnet = new btcCore.NetworkType(
      messagePrefix: '\x18Bitcoin Signed Message:\n',
      bech32: 'tb',
      bip32: new btcCore.Bip32Type(
      public: 0x043587cf, private: 0x04358394),
      pubKeyHash: 0x6f,
      scriptHash: 0xc4,
      wif: 0xef);


  @override
  String get coinInfo => "莱特币（Ltc）";
  @override
  String get imagePath => "coin/LTC";

}