
import 'package:bip32/bip32.dart';
import 'package:bip39/bip39.dart' as bip39;
import 'package:bitcoin_flutter/bitcoin_flutter.dart' as btcCore;
import 'package:wallet_hd_coins/utils/StringUtil.dart';
import 'package:wallet_hd_coins/wallet_hd_coins.dart';
abstract class CoinsBase{
  btcCore.HDWallet hdMain;
  CoinsBase(){
    if(StringUtil.isEmpty(getMnemonic)){
      throw "助记词不能为空";
    }
    if(network.runtimeType.toString() ==  "NetworkType") //因为只有比特币系列的才需要在这里指定network
    {
      hdMain = btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic), network:network);
    }
    else
      hdMain = btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic));
  }
  Object get network;
  String get coinType;
  String get coinInfo;
  String get imagePath;
  bool get isOpen;
  // bool  isHaveToken = false; //不再需要让用户添加token的合约，因为签名的数据里附带了合约地址
  // int get gasLimit=>0;
  int get decimals;//小数位
  String get getMnemonic{ //获取助记词
    return WalletHdCoins.mnemonicW;
  }
  String  derivePath(String subPath);
  Future<String>  getAddress(String subPath);
  Future<String> getPrivateKey(String subPath) async{
    // if(StringUtil.isEmpty(getMnemonic)){
    //   throw "助记词不能为空";
    // }
    btcCore.HDWallet hdSub = hdMain.derivePath(derivePath(subPath));
    // btcCore.HDWallet hdWalletEth =
    // btcCore.HDWallet.fromSeed(bip39.mnemonicToSeed(getMnemonic))
    //     .derivePath(derivePath(subPath));
    // String privateKey = hdWalletEth.privKey;
    String privateKey = hdSub.privKey;
    return privateKey;
  }
  //获取扩展公钥
  Future<String> getXpub() async{
     return hdMain.base58;
  }
  Future<String> transactionMain(
      String subPath,
      String fromAddress,
      String toAddress,
      num amount,
      num gasPrice,
      Map otherPrams
      );
   Future<String> transactionToken(
       String subPath,
       String fromAddress,
       String toAddress,
       num amount,
       num gasPrice,
       String contractAddress,
       int decimalForToken,
       Map otherPrams
      );

  bool isEmpty(String str){
    return str == null || str.length == 0;
  }
}