
import 'dart:async';

import 'package:flutter/services.dart';

import 'package:bip39/bip39.dart' as bip39;
import 'btc/coins_bch.dart';
import 'btc/coins_btc.dart';
import 'btc/coins_ltc.dart';
import 'coins_base.dart';
import 'eth/coins_bsc.dart';
import 'eth/coins_etc.dart';
import 'eth/coins_eth.dart';
import 'eth/coins_heco.dart';
import 'eth/coins_okt.dart';
import 'trx/coins_trx.dart';
import 'fil/coins_fil.dart';
class WalletHdCoins {

  static const MethodChannel _channel =
      const MethodChannel('wallet_hd_coins');

  static Future<String> get platformVersion async {

    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }
  static bool isTestNetWork = false;//是否开启测试网络
  static String mnemonicW;//全局组记词
  static final  Map<String,CoinsBase> allCoinCores =  {
    CoinsBtc().coinType:CoinsBtc(),
    CoinsLtc().coinType:CoinsLtc(),
    CoinsBch().coinType:CoinsBch(),
    CoinsEth().coinType:CoinsEth(),
    CoinsEtc().coinType:CoinsEtc(),
    CoinsTrx().coinType:CoinsTrx(),
    CoinsHeco().coinType:CoinsHeco(),
    CoinsBsc().coinType:CoinsBsc(),
    CoinsOkt().coinType:CoinsOkt(),
    // CoinsFil().coinType:CoinsFil(),

  };
  static String getSubPath(int groupId,int index){
    return "0'/$groupId/$index";
  }
  //获取助记词
  static String getWords(String passWord)  {

    String randomMnemonic = bip39.generateMnemonic();
    return randomMnemonic;
  }
  static bool validateMnemonic(String mnemonic){
    return bip39.validateMnemonic(mnemonic);
  }
  static bool isEmpty(String str){
    return str == null || str.length == 0;
  }
}
